(function() {
    'use strict';

    angular.module('wemGaApp').config(wemGaAppConfig);

    function wemGaAppConfig($mdThemingProvider,$mdToastProvider){
        $mdThemingProvider.theme("wemga").primaryPalette("teal").accentPalette("deep-purple").warnPalette("red");
        $mdThemingProvider.setDefaultTheme("wemga");
        //TODO make it work
        //$mdToastProvider.;
    }
})();
(function() {
    'use strict';

    angular.module('wemGaApp').controller(WemGaAppController);

    WemGaAppController.$inject = ['$scope','$sce', '$mdToast', 'jcrService', 'i18nService'];

    function WemGaAppController($scope,$sce,$mdToast,jcrService, i18nService){
        $scope.configuration = {
            identifier:null,
            newTag : null,
            weekNumber : null,
            hashtag : null,
            pages:[],
            folders:[],
            nodes:{},
            nofile : true
        };
        $scope.atsettings = {
            autofill:true,
            insertTag:true
        };
        $scope.tree = [];
        $scope.selectedPath = "";
        $scope.pathSelected = false;
        $scope.selectMessage = "";
        $scope.enablePicker = false;
        $scope.nodes=[];
        $scope.messageToDisplay = false;
        $scope.message="";

        $scope.changeMixins = function(type, mixinURL){
            //If true adding mixins if false removing mixins
            if(type){
                if (confirm(messages.addMessage)) {
                    $scope.addRemoveMixins(mixinURL,type);
                }
            } else {
                if (confirm(messages.removeMessage)) {
                    $scope.addRemoveMixins(mixinURL,type);
                }
            }
        }

        $scope.addRemoveMixins = function(url, type){
            jcrService.callAction(url).success(function(response){
                if(response.result.success == 'true'){
                    $mdToast.show($mdToast.simple().textContent(messages.successMessage).position("top right"));
                }
            }).error(function(response){
                $mdToast.show($mdToast.simple().textContent(messages.errorMessage).position("top right"));
            });
        };

        $scope.updateConfiguration = function(){
            var fileNode = $scope.configuration.nodes[$scope.atsettings.file];
            jcrService.doUpdateNodeById(urlContext,"default","en",$scope.configuration.node.id,{
                "properties":{
                    "autofill":{"value" : $scope.atsettings.autofill},
                    "inserttag":{"value" : $scope.atsettings.insertTag}
                }}).success(function(){
                $scope.message = "Configuration updated";
                $mdToast.show($mdToast.simple().textContent($scope.message).position("top right"));
            }).error(function(response){console.error("atinternetConfiguration.js - Error in creation !"); });
        };

        $scope.getConfiguration = function(configurationPath, urlContext){
            //get Configuration node
            jcrService.doGetOnPath(urlContext, 'default', 'en', configurationPath).success(function(response) {
                $scope.configuration.node = response;
                if($scope.configuration.node.properties.username != undefined){
                    $scope.atsettings.username = $scope.configuration.node.properties.username.value;
                }
                if($scope.configuration.node.properties.password != undefined){
                    $scope.atsettings.password = $scope.configuration.node.properties.password.value;
                }
                if($scope.configuration.node.properties.autofill != undefined){
                    $scope.atsettings.autofill = $scope.configuration.node.properties.autofill.value;
                }
                if($scope.configuration.node.properties.inserttag != undefined){
                    $scope.atsettings.insertTag = $scope.configuration.node.properties.inserttag.value;
                }
            }).error(function(response){
                //Tiles folder doesn't exist for that site
                console.error("wemga-configuration.js - no configuration node found");
            });
        };
        $scope.getConfiguration(sitePath+'/contents/wemga-settings', urlContext);
    }
})();
(function() {
    'use strict';

    angular.module('wemGaApp', ['ngMaterial', 'ngAnimate', 'ngMessages', 'jcrServices', 'i18n', 'underscore']);

})();
(function() {
    'use strict';

    angular.module('wemGaApp').service('jcrService', jcrService);

    jcrService.$inject = ['$http'];

    function jcrService($http) {

        return {
            addMixin: addMixin,
            doGetOnPath: doGetOnPath,
            doGetOnPathSync: doGetOnPathSync
        };

        function addMixin(workspace, locale, nodeIdOrPath, mixin, mixinProperties, byPath) {
            var apiType = byPath ? "paths" : "nodes";
            nodeIdOrPath = byPath ? nodeIdOrPath : "/" + nodeIdOrPath;
            var url = _buildURL(workspace, locale, apiType, nodeIdOrPath) + "/mixins/" + mixin.replace(":", "__");
            return mixinProperties ? $http.put(url, mixinProperties) : $http.put(url);
        }

        function doGetOnPath(workspace, locale, path) {
            return $http.get(_buildURL(workspace, locale, "paths", path));
        }

        function doGetOnPathSync(workspace, locale, path) {
            var request = new XMLHttpRequest();
            request.open('GET', _buildURL(workspace, locale, "paths", path), false);
            request.send(null);

            return request.status === 200;
        }

        // Private function under this line
        function _buildURL(workspace, locale, type, endUrl) {
            return [ManagersContext.jcrRestAPIBase,
                    workspace ? workspace : "default",
                    locale ? locale : ManagersContext.currentSiteDefaultLanguage,
                    type ? type : "nodes"].join("/") + endUrl;
        }
    }
})();
(function() {
    'use strict';

    angular.module('i18n', []);
})();
(function() {
    'use strict';

    angular.module('i18n').directive('messageKey', messageKeyDirective);

    messageKeyDirective.$inject = ['i18nService'];

    function messageKeyDirective(i18nService) {
        return {
            restrict: 'A',
            link: function (scope, element, attrs) {
                var i18n;
                if(!attrs.messageParams){
                    i18n = i18nService.message(attrs.messageKey);
                } else {
                    i18n = i18nService.format(attrs.messageKey, attrs.messageParams);
                }

                if(attrs.messageAttr) {
                    // store the i18n in the specified element attr
                    element.attr(attrs.messageAttr, i18n);
                } else {
                    // set the i18n as element text
                    element.text(i18n);
                }
            }
        };
    }
})();
(function() {
    'use strict';

    angular.module('i18n').filter('translate', translateFilter);

    translateFilter.$inject = ['i18nService'];

    function translateFilter(i18nService) {
        return function(input) {
            return i18nService.message(input);
        };
    }
})();
(function() {
    'use strict';

    angular.module('i18n').service('i18nService', i18nService);

    function i18nService() {
        var _i18nMap = {};

        return {
            initMap: initMap,
            addKeyToMap: addKeyToMap,
            message: message,
            format: format,
            contains: contains
        };

        function contains(key) {
            return (_i18nMap && _i18nMap[key]);
        }

        function message(key) {
            if (_i18nMap && _i18nMap[key]) {
                return _i18nMap[key];
            } else {
                return '???' + key + '???';
            }
        }

        function format(key, params) {
            var replacer = function(params){
                return function(s, index) {
                    return params[index] ? (params[index] == '__void__' ? '' : params[index]) : '';
                };
            };

            if(params){
                if (_i18nMap && _i18nMap[key]) {
                    return _i18nMap[key].replace(/\{(\w+)\}/g, replacer(params.split('|')));
                } else {
                    return '???' + key + '???';
                }
            } else {
                return this.message(key);
            }
        }

        function addKeyToMap(newI18nMap) {
            angular.forEach(newI18nMap, function (value, key) {
                _i18nMap[key] = value;
            });
        }

        function initMap(i18nMap) {
            _i18nMap = i18nMap;
        }
    }
})();
